package assignment2;

import static org.junit.Assert.assertArrayEquals;

import org.junit.Test;

public class SearchTest {
	private TestUtils util = new TestUtils();
	
	@Test
	public void testUnsorted() {
		int[] small = new int[] { 5, 2, 4, 1, 4 };

		assertArrayEquals(new int[] { 2, 4 }, Search.findUnsorted(4, small));
		assertArrayEquals(new int[] { 3 }, Search.findUnsorted(1, small));
	}
    
	@Test
	public void testUnsortedBig() {
		int[] big = util.readIntArrayResource("/assignment2/resources/big_array.txt");

		assertArrayEquals(new int[] { 998 }, Search.findUnsorted(30, big));
		assertArrayEquals(new int[] { 254,277 }, Search.findUnsorted(4, big));
	}

	@Test
	public void testUnsortedEmpty() {
		int exceptedPos[] = {};
		
		int[] array = new int[] { 5, 2, 4, 1, 4 };
		int founds[] = Search.findSorted(3, array);
		assertArrayEquals(founds, exceptedPos);
		
		array = util.readIntArrayResource("/assignment2/resources/big_array.txt");
		founds = Search.findSorted(5, array);
		assertArrayEquals(founds, exceptedPos);
	}

	@Test
	public void testSorted() {
		int[] small = new int[] { 1, 2, 4, 4, 5 };

		assertArrayEquals(new int[] { 2, 3 }, Search.findSorted(4, small));
		assertArrayEquals(new int[] { 0 }, Search.findSorted(1, small));
	}

	@Test
	public void testSortedBig() {
		int[] big = util.readIntArrayResource("/assignment2/resources/big_array.sorted.txt");

		assertArrayEquals(new int[] { 0 }, Search.findSorted(1, big));
		assertArrayEquals(new int[] { 1,2 }, Search.findSorted(3, big));
	}
	@Test
	public void testSortedEmpty() {
		int exceptedPos[] = {};

		int[] array = new int[] { 1, 2, 4, 4, 5 };
		int founds[] = Search.findSorted(3, array);
		assertArrayEquals(founds, exceptedPos);
		
		array = util.readIntArrayResource("/assignment2/resources/big_array.sorted.txt");
		founds = Search.findSorted(5, array);
		assertArrayEquals(founds, exceptedPos);
	}
}
